
Indic.5y.in.Xy <- 1

# The length of the folllwing vectors correspond to the number of graphics made:
area.1st.left.panels <- c("EA","EA")
area.2nd.left.panels <- c("US","US")
area.1st.right.panels <- c("EA","EA")
area.2nd.right.panels <- c("US","US")

# The length of the folllwing vectors correspond to the number of graphics made:
vec.lower.bounds.left.panels.1st.area <- c(1.5,1.5)
vec.lower.bounds.left.panels.2nd.area <- c(1.5,1.8)
vec.upper.bounds.left.panels.1st.area <- c(2.5,2.5)
vec.upper.bounds.left.panels.2nd.area <- c(2.5,2.8)
vec.lower.bounds.right.panels.1st.area <- c(1,1)
vec.lower.bounds.right.panels.2nd.area <- c(1,1.3)
vec.upper.bounds.right.panels.1st.area <- c(3,3)
vec.upper.bounds.right.panels.2nd.area <- c(3,3.3)

vec.HH <- c(60,120) # maturities considered in the different plots; first for upper plot, second for lower plot

vec.indic.average <- c(0,1) # in 0,1,2 # 1 for averages over periods

KF.res.0 <- KF.res
# Get smoothed factors:
X <- KF.res.0$r_smooth
Sigma.X <- KF.res.0$S_smooth

# Calibration of parameters 
step.4.integral <- .02
max.v.4.integral <- 50

max.x <- log(max.v.4.integral)
v <- matrix(exp(seq(-10,max.x,by=step.4.integral)),nrow=1)
dim.v <- length(v)

HHH <- seq(12,120,by=12)

for(i.plot in 1:length(area.1st.left.panels)){# loop on charts
  
  
  # ===========================================================
  # Prepare graphics
  # ===========================================================
  
  FILE = paste("/OUTPUTS/Figure_anchoring_proba_",toString(i.plot),".pdf",sep="")
  pdf(file=paste(getwd(),FILE,sep=""),pointsize=10,width=8, height=10)
  
  par(mfrow=c(length(vec.indic.average),2))
  par(plt=c(.1,.95,.1,.85))
  
  matrix.of.results <- NULL
  
  for(panel in c("left","right")){
    
    all.proba.1st.area <- NULL
    all.lower.bounds.1st.area <- NULL
    all.upper.bounds.1st.area <- NULL
    all.proba.2nd.area <- NULL
    all.lower.bounds.2nd.area <- NULL
    all.upper.bounds.2nd.area <- NULL
    all.proba.diff <- NULL
    all.lower.bounds.diff <- NULL
    all.upper.bounds.diff <- NULL
    
    print(paste(panel,"panel"))
    
    for(case in 1:length(vec.HH)){# loop on row of charts
      
      indic.average <- vec.indic.average[case]
      
      for(AREA in 1:2){
        
        if(AREA==1){
          if(panel=="left"){
            area <- ifelse(area.1st.left.panels[i.plot]=="EA",1,2)
          }else{# right panel
            area <- ifelse(area.1st.right.panels[i.plot]=="EA",1,2)
          }
        }else{# second considered area
          if(panel=="left"){
            area <- ifelse(area.2nd.left.panels[i.plot]=="EA",1,2)
          }else{# right panel
            area <- ifelse(area.2nd.right.panels[i.plot]=="EA",1,2)
          }
        }
        
        b <- c(estimated.Model$delta[,area],rep(0,estimated.Model$q))
        u_Y <- 1i * matrix(b[1:estimated.Model$n],ncol=1) %*% v 
        u_z <- 1i * matrix(b[(estimated.Model$n+1):(estimated.Model$n+estimated.Model$q)],ncol=1) %*% v  # our paper, section 7.3 Appendix i*v*gamma for z
        AB.list <- compute_AB(estimated.Model,u_Y,u_z,HHH,indic.average)

        if(area==1){
          AB.list.1 <- AB.list
        }else{
          AB.list.2 <- AB.list
        }
        
      }
      
      HH <- vec.HH[case]
      
      indic.matur <- which(HH==HHH)
      
      for(AREA in 1:2){
        
        if(AREA==1){
          if(panel=="left"){
            area <- ifelse(area.1st.left.panels[i.plot]=="EA",1,2)
            lower.bound <- vec.lower.bounds.left.panels.1st.area[i.plot]
            upper.bound <- vec.upper.bounds.left.panels.1st.area[i.plot]
          }else{# right panel
            area <- ifelse(area.1st.right.panels[i.plot]=="EA",1,2)
            lower.bound <- vec.lower.bounds.right.panels.1st.area[i.plot]
            upper.bound <- vec.upper.bounds.right.panels.1st.area[i.plot]
          }
        }else{# second considered area
          if(panel=="left"){
            area <- ifelse(area.2nd.left.panels[i.plot]=="EA",1,2)
            lower.bound <- vec.lower.bounds.left.panels.2nd.area[i.plot]
            upper.bound <- vec.upper.bounds.left.panels.2nd.area[i.plot]
          }else{# right panel
            area <- ifelse(area.2nd.right.panels[i.plot]=="EA",1,2)
            lower.bound <- vec.lower.bounds.right.panels.2nd.area[i.plot]
            upper.bound <- vec.upper.bounds.right.panels.2nd.area[i.plot]
          }
        }
        
        print(c(lower.bound,upper.bound))
        
        print(paste("Case: ",toString(case),"; Area: ",toString(area),sep=""))
        
        b <- c(estimated.Model$delta[,area],rep(0,estimated.Model$q))
        
        lower.bound.bX <- lower.bound - estimated.Model$pi.bar[area]
        upper.bound.bX <- upper.bound - estimated.Model$pi.bar[area]
        
        if(area==1){
          AB.list <- AB.list.1
        }else{
          AB.list <- AB.list.2
        }
        AB.list.external <- list(A=array(AB.list$A[,,indic.matur],c(dim(AB.list$A)[1],dim(AB.list$A)[2],1)),
                                 B=array(AB.list$B[,,indic.matur],c(dim(AB.list$B)[1],dim(AB.list$B)[2],1)))
        
        
        res.analytical.computation <-
          compute.proba.interval.plus.stdv(estimated.Model,X,b,HH,
                                           lower.bound.bX,upper.bound.bX,
                                           step.4.integral,max.v.4.integral,indic.average,
                                           Sigma.X,AB.list.external)
        
        if(AREA==1){
          all.proba.1st.area <- cbind(all.proba.1st.area,res.analytical.computation$Proba)
          all.lower.bounds.1st.area <- cbind(all.lower.bounds.1st.area,res.analytical.computation$Proba - 2*res.analytical.computation$Proba.stdv)
          all.upper.bounds.1st.area <- cbind(all.upper.bounds.1st.area,res.analytical.computation$Proba + 2*res.analytical.computation$Proba.stdv)
        }else{
          all.proba.2nd.area <- cbind(all.proba.2nd.area,res.analytical.computation$Proba)
          all.lower.bounds.2nd.area <- cbind(all.lower.bounds.2nd.area,res.analytical.computation$Proba - 2*res.analytical.computation$Proba.stdv)
          all.upper.bounds.2nd.area <- cbind(all.upper.bounds.2nd.area,res.analytical.computation$Proba + 2*res.analytical.computation$Proba.stdv)
        }
      }
      
      # Differences of proba:
      AB.list <- AB.list.1
      AB.list.external.1 <- list(A=array(AB.list$A[,,indic.matur],c(dim(AB.list$A)[1],dim(AB.list$A)[2],1)),
                                 B=array(AB.list$B[,,indic.matur],c(dim(AB.list$B)[1],dim(AB.list$B)[2],1)))
      AB.list <- AB.list.2
      AB.list.external.2 <- list(A=array(AB.list$A[,,indic.matur],c(dim(AB.list$A)[1],dim(AB.list$A)[2],1)),
                                 B=array(AB.list$B[,,indic.matur],c(dim(AB.list$B)[1],dim(AB.list$B)[2],1)))
      
      if(panel=="left"){
        wedge <- vec.lower.bounds.left.panels.2nd.area[i.plot]-
          vec.lower.bounds.left.panels.1st.area[i.plot]
      }else{# right panel
        wedge <- vec.lower.bounds.right.panels.2nd.area[i.plot]-
          vec.lower.bounds.right.panels.1st.area[i.plot]
      }
      print(paste("wedge:",toString(wedge)))
      
      res.diff.proba <- compute.difference.proba.plus.stdv(estimated.Model,X,HH,
                                                           lower.bound-wedge,upper.bound-wedge,
                                                           step.4.integral,max.v.4.integral,indic.average,
                                                           Sigma.X,AB.list.external.1,AB.list.external.2,
                                                           wedge)
      
      all.proba.diff <- cbind(all.proba.diff,res.diff.proba$Proba.diff)
      all.lower.bounds.diff <- cbind(all.lower.bounds.diff,res.diff.proba$Proba.diff - 2*res.diff.proba$Proba.diff.stdv)
      all.upper.bounds.diff <- cbind(all.upper.bounds.diff,res.diff.proba$Proba.diff + 2*res.diff.proba$Proba.diff.stdv)
      
    }
    
    # GRAPHICS
    
    
    for(i in 1:length(vec.indic.average)){
      
      if(panel=="left"){
        if(vec.lower.bounds.left.panels.1st.area[i.plot]==1.5){
          if(i==1){
            main.tit <- expression(paste(
              "Interval: [1.5%,2.5%], 1-yr 4-yrs-ahead infl. (",
              pi[t+48*","*t+60],")",sep=""))}
          if(i==2){
            main.tit <- expression(paste(
              "Interval: [1.5%,2.5%], 5-yr 5-yrs-ahead infl. (",
              pi[t+60*","*t+120],")",sep=""))}
        }else{
          if(i==1){
            main.tit <- expression(paste(
              "Interval: [1%,3%], 1-yr 4-yrs-ahead infl. (",
              pi[t+48*","*t+60],")",sep=""))}
          if(i==2){
            main.tit <- expression(paste(
              "Interval: [1%,3%], 5-yr 5-yrs-ahead infl. (",
              pi[t+60*","*t+120],")",sep=""))}
        }
      }else{#right panel
        if(vec.lower.bounds.right.panels.1st.area[i.plot]==1.5){
          if(i==1){
            main.tit <- expression(paste(
              "Interval: [1.5%,2.5%], 1-yr 4-yrs-ahead infl. (",
              pi[t+48*","*t+60],")",sep=""))}
          if(i==2){
            main.tit <- expression(paste(
              "Interval: [1.5%,2.5%], 5-yr 5-yrs-ahead infl. (",
              pi[t+60*","*t+120],")",sep=""))}
        }else{
          if(i==1){
            main.tit <- expression(paste(
              "Interval: [1%,3%], 1-yr 4-yrs-ahead infl. (",
              pi[t+48*","*t+60],")",sep=""))}
          if(i==2){
            main.tit <- expression(paste(
              "Interval: [1%,3%], 5-yr 5-yrs-ahead infl. (",
              pi[t+60*","*t+120],")",sep=""))}
        }
      }
      
      if(i<3){
        y.lim <- c(0,.8)
      }else{
        y.lim <- c(-0.1,1)
      }
      
      y.lim <- c(-0.1,1)
      
      print("------------")
      print("Plot:")
      print(c(i,ifelse(panel=="left",1,2)))
      print("------------")
      
      par(mfg=c(i,ifelse(panel=="left",1,2)))
      plot(vec.dates,rep(0,length(vec.dates)),type="l",
           ylim=y.lim,
           xlab="",ylab="",
           main=main.tit,col="white")
      
      for(AREA in 1:2){
        
        if(AREA==1){
          if(panel=="left"){
            area <- ifelse(area.1st.left.panels[i.plot]=="EA",1,2)
          }else{# right panel
            area <- ifelse(area.1st.right.panels[i.plot]=="EA",1,2)
          }
        }else{# second considered area
          if(panel=="left"){
            area <- ifelse(area.2nd.left.panels[i.plot]=="EA",1,2)
          }else{# right panel
            area <- ifelse(area.2nd.right.panels[i.plot]=="EA",1,2)
          }
        }
        
        if(area==1){
          Area <- "Euro area"
          rec.dates <- EA.rec.dates
          col.recess.areas <- "#EECCEEBB"
        }
        if(area==2){
          Area <- "United States"
          rec.dates <- US.rec.dates
          col.recess.areas <- "#CCEEEEBB"
        }
        
        #------ Add recession areas ------
        nb.rec <- length(rec.dates)/8
        par(mfg=c(i,ifelse(panel=="left",1,2)))
        polygon(rec.dates,c(rep(c(-10000,10000,10000,-10000),nb.rec),rep(-10000,nb.rec*4)),
                col=col.recess.areas,border=NA)
        #---------------------------------
      }
      
      announc.infl.target <- as.Date("15-05-2003","%d-%m-%Y")
      par(mfg=c(i,ifelse(panel=="left",1,2)))
      lines(c(announc.infl.target,announc.infl.target),c(-100,100),lwd=2,lty=2,col="red")
      announc.infl.target <- as.Date("15-01-2012","%d-%m-%Y")
      par(mfg=c(i,ifelse(panel=="left",1,2)))
      lines(c(announc.infl.target,announc.infl.target),c(-100,100),lwd=2,col="red")
      
      
      for(AREA in 1:2){
        
        if(AREA==1){
          if(panel=="left"){
            area <- ifelse(area.1st.left.panels[i.plot]=="EA",1,2)
          }else{# right panel
            area <- ifelse(area.1st.right.panels[i.plot]=="EA",1,2)
          }
        }else{# second considered area
          if(panel=="left"){
            area <- ifelse(area.2nd.left.panels[i.plot]=="EA",1,2)
          }else{# right panel
            area <- ifelse(area.2nd.right.panels[i.plot]=="EA",1,2)
          }
        }
        
        if(AREA==1){
          proba <- all.proba.1st.area[,i]
          lower.bound <- all.lower.bounds.1st.area[,i]
          upper.bound <- all.upper.bounds.1st.area[,i]
          color.l <- "dark gray"
        }else{
          proba <- all.proba.2nd.area[,i]
          lower.bound <- all.lower.bounds.2nd.area[,i]
          upper.bound <- all.upper.bounds.2nd.area[,i]
          color.l <- "black"
        }
        
        par(mfg=c(i,ifelse(panel=="left",1,2)))
        polygon(c(vec.dates,vec.dates[length(vec.dates):1]),c(lower.bound,upper.bound[length(vec.dates):1]),
                col="#90909044",border=NA)
        par(mfg=c(i,ifelse(panel=="left",1,2)))
        lines(vec.dates,proba,col=color.l,
              lwd=2)
        
        eval(parse(text = gsub('','',
                               paste('variable.name <- "ancho.measur.',
                                     ifelse(i==1,'1Y4F.','5Y5F.'),
                                     ifelse(area==1,'EA.','US.'),
                                     ifelse(panel=="left",'leftpanel"','rightpanel"'),
                                     "",sep=""))))
        eval(parse(text = gsub('','',
                               paste(variable.name,'<- proba',sep=""))))
        eval(parse(text = gsub('','',
                               paste('matrix.of.results <- cbind(matrix.of.results,',
                                     variable.name,')',
                                     "",sep=""))))
        
      }
      
      diff.proba <- all.proba.diff[,i]
      diff.lower <- all.lower.bounds.diff[,i]
      diff.upper <- all.upper.bounds.diff[,i]
      
      par(mfg=c(i,ifelse(panel=="left",1,2)))
      polygon(c(vec.dates,vec.dates[length(vec.dates):1]),c(diff.lower,diff.upper[length(vec.dates):1]),
              col="#90909044",border=NA)
      par(mfg=c(i,ifelse(panel=="left",1,2)))
      lines(vec.dates,diff.proba,col=color.l,lty=3,
            lwd=3)
      
      par(mfg=c(i,ifelse(panel=="left",1,2)))
      abline(h=0,col="dark grey")
      
      if(panel=="left"){
        name.1st.area <- area.1st.left.panels[i.plot]
        if((name.1st.area=="US")&(vec.lower.bounds.left.panels.1st.area[i.plot] %in% c(1.3,1.8))){
          name.1st.area <- "United States (PCE)"
        }
        if((name.1st.area=="US")&(vec.lower.bounds.left.panels.1st.area[i.plot] %in% c(1,1.5))){
          name.1st.area <- "United States (CPI)"
        }
        if(name.1st.area=="EA"){
          name.1st.area <- "Euro Area"
        }
        name.2nd.area <- area.2nd.left.panels[i.plot]
        if((name.2nd.area=="US")&(vec.lower.bounds.left.panels.2nd.area[i.plot] %in% c(1.3,1.8))){
          name.2nd.area <- "United States (PCE)"
        }
        if((name.2nd.area=="US")&(vec.lower.bounds.left.panels.2nd.area[i.plot] %in% c(1,1.5))){
          name.2nd.area <- "United States (CPI)"
        }
        if(name.2nd.area=="EA"){
          name.2nd.area <- "Euro Area"
        }
      }else{#right panel
        name.1st.area <- area.1st.right.panels[i.plot]
        if((name.1st.area=="US")&(vec.lower.bounds.right.panels.1st.area[i.plot] %in% c(1.3,1.8))){
          name.1st.area <- "United States (PCE)"
        }
        if((name.1st.area=="US")&(vec.lower.bounds.right.panels.1st.area[i.plot] %in% c(1,1.5))){
          name.1st.area <- "United States (CPI)"
        }
        if(name.1st.area=="EA"){
          name.1st.area <- "Euro Area"
        }
        name.2nd.area <- area.2nd.right.panels[i.plot]
        if((name.2nd.area=="US")&(vec.lower.bounds.right.panels.2nd.area[i.plot] %in% c(1.3,1.8))){
          name.2nd.area <- "United States (PCE)"
        }
        if((name.2nd.area=="US")&(vec.lower.bounds.right.panels.2nd.area[i.plot] %in% c(1,1.5))){
          name.2nd.area <- "United States (CPI)"
        }
        if(name.2nd.area=="EA"){
          name.2nd.area <- "Euro Area"
        }
      }
      
      if(i==2){
        legend("bottomleft",
               c(name.1st.area,name.2nd.area,"Difference"),
               lty=c(1,1,3),
               pch = c(NaN,NaN,NaN),
               lwd=c(2,2,3), # line width
               col=c("dark grey","black","black"),
               cex=1,bg="white",seg.len=4)  
      }else{
        legend("bottomleft",
               c(name.1st.area,name.2nd.area,"Difference"),
               lty=c(1,1,3),
               pch = c(NaN,NaN,NaN),
               lwd=c(2,2,3),
               col=c("dark grey","black","black"),
               cex=1,bg="white",seg.len=4)  
      }
    }
  }
  
  dev.off()
  
  write.csv(matrix.of.results,file=paste("OUTPUTS/anchoring_measures_",toString(i.plot),".csv",sep=""))
}





