
Indic.5y.in.Xy <- 0

if(indic.whether.recompute.PDFs==0){
  FILE = paste("PDFs/analytical.pdfs.",estimated.Model$areas,
               ".n",toString(estimated.Model$n),
               ".q",toString(estimated.Model$q),
               ".res",sep="")
  load(file=FILE)
}else{
  print(" -------------------------------------------")
  print(" -- Computing conditional disitrbution -----")
  print(" --  (takes about a couple of minutes)  ----")
  print(" -------------------------------------------")
  source('compute.analytical.distri.R')
}



# Select monthes:

#for Euro Area:
considered.months.EA <- as.Date(c("15/01/2004","15/03/2015"),"%d/%m/%Y")
#for US:
considered.months.US <- as.Date(c("15/01/2004","15/03/2015"),"%d/%m/%Y")


#for Euro Area:
considered.months.EA <- as.Date(c("15/02/2005","15/04/2016"),"%d/%m/%Y")
#for US:
considered.months.US <- as.Date(c("15/01/2005","15/01/2016"),"%d/%m/%Y")


vector.quantiles <- c(.1,.5,.9)

FILE = "/OUTPUTS/Figure_term_structure.pdf"
pdf(file=paste(getwd(),FILE,sep=""),pointsize=10,width=8, height=8)

par(plt=c(.2,.95,.15,.85))
par(mfrow=c(2,estimated.Model$r))

for(inflation.type in 1:2){
  
  for(area in 1:estimated.Model$r){
    if((area==1)&(inflation.type==1)){
      Area <- expression(paste("Euro area, inflation rates ",pi[t*","*t+h],sep=""))
      considered.months <- considered.months.EA
    }
    if((area==2)&(inflation.type==1)){
      Area <- expression(paste("United States, inflation rates ",pi[t*","*t+h],sep=""))
      considered.months <- considered.months.US
    }
    if((area==1)&(inflation.type==2)){
      Area <- expression(paste("Euro area, forward inflation rates ",pi[t+h-12*","*t+h],sep=""))
      considered.months <- considered.months.EA
    }
    if((area==2)&(inflation.type==2)){
      Area <- expression(paste("United States, forward inflation rates ",pi[t+h-12*","*t+h],sep=""))
      considered.months <- considered.months.US
    }
    count <- 0
    
    vec.tt <- which(vec.dates %in% considered.months)
    x.values <- PDF.x.all[area,] + estimated.Model$pi.bar[area]
    if(inflation.type==1){
      all.quantiles <- apply(CDF.average.all[vec.tt,,,area],c(1,3),function(x){
        interporlate.quantile(x,vector.quantiles,x.values)})
    }else{
      all.quantiles <- apply(CDF.all[vec.tt,,,area],c(1,3),function(x){
        interporlate.quantile(x,vector.quantiles,x.values)})
    }
    
    Median <- all.quantiles[2,,]
    lower.b <- all.quantiles[1,,]
    upper.b <- all.quantiles[3,,]
    
    count <- 0
    for(month.4.distri in considered.months){
      count <- count + 1
      if(count==1){
        plot(HHH/12,Median[count,],
             type="l",ylim=c(-.5,4),xlab=expression(paste("Horizon, years (=",h/12,")",sep="")),ylab="percent",
             main = Area)
        polygon(c(HHH/12,HHH[length(HHH):1]/12),
                c(lower.b[count,],upper.b[count,length(HHH):1]),
                col="#11111122")
        lines(HHH/12,Median[count,],lwd=3)
      }else{
        polygon(c(HHH/12,HHH[length(HHH):1]/12),
                c(lower.b[count,],upper.b[count,length(HHH):1]),
                col="#44444422",lty=2)
        lines(HHH/12,Median[count,],
              col="red",lty=2,lwd=3)
      }
    }
    legend("bottomright",
           c(as.character(format(considered.months,"%m-%Y"))),
           lty=c(1,2),
           lwd=c(3,3),
           col=c("black","red"),
           seg.len=4)  
  }
  
  
}

dev.off()




# Chart with TS of variances
# ==========================================

X <- KF.res$r_smooth
S <- KF.res$S_smooth

T <- dim(X)[1]


all.res.EA.type.1 <- NULL
all.res.US.type.1 <- NULL
all.res.EA.type.2 <- NULL
all.res.US.type.2 <- NULL

vec.HH.1 <- seq(12,120,by=12)
count <- 0
for(HH in vec.HH.1){
  count <- count + 1
  all.res <- compute.two.moments(estimated.Model,X,HH,S, indic.5y.in.Xy = 0)
  all.res.EA.type.1 <- cbind(all.res.EA.type.1,all.res$expect.2nd.mom[,1,1])
  all.res.US.type.1 <- cbind(all.res.US.type.1,all.res$expect.2nd.mom[,2,1])
}

vec.HH.2 <- seq(12,120,by=3)
count <- 0
for(HH in vec.HH.2){
  count <- count + 1
  all.res <- compute.two.moments(estimated.Model,X,HH,S, indic.5y.in.Xy = 0)
  all.res.EA.type.2 <- cbind(all.res.EA.type.2,all.res$expect.2nd.mom[,1,2])
  all.res.US.type.2 <- cbind(all.res.US.type.2,all.res$expect.2nd.mom[,2,2])
}

vec.tt <- which(vec.dates %in% considered.months)


FILE = "/OUTPUTS/Figure_term_structure_variances.pdf"
pdf(file=paste(getwd(),FILE,sep=""),pointsize=10,width=8, height=8)

par(plt=c(.1,.95,.15,.85))
par(mfrow=c(2,estimated.Model$r))

for(inflation.type in 1:2){
  
  if(inflation.type==1){
    vec.HH <- vec.HH.1
  }else{
    vec.HH <- vec.HH.2
  }
  
  for(area in 1:estimated.Model$r){
    if((area==1)&(inflation.type==1)){
      Area <- expression(paste("Euro area, Var. of inflation rates ",pi[t*","*t+h],sep=""))
      considered.months <- considered.months.EA
      y.data <- all.res.EA.type.1[vec.tt,]
      y.lim=c(0,1.0)
    }
    if((area==2)&(inflation.type==1)){
      Area <- expression(paste("United States, Var. of inflation rates ",pi[t*","*t+h],sep=""))
      considered.months <- considered.months.US
      y.data <- all.res.US.type.1[vec.tt,]
      y.lim=c(0,1.0)
    }
    if((area==1)&(inflation.type==2)){
      Area <- expression(paste("Euro area, Var. of forward inflation rates ",pi[t+h-12*","*t+h],sep=""))
      considered.months <- considered.months.EA
      y.data <- all.res.EA.type.2[vec.tt,]
      y.lim=c(0,1.1)
    }
    if((area==2)&(inflation.type==2)){
      Area <- expression(paste("United States, Var. of forward inflation rates ",pi[t+h-12*","*t+h],sep=""))
      considered.months <- considered.months.US
      y.data <- all.res.US.type.2[vec.tt,]
      y.lim=c(0,1.1)
    }
    
    y.data <- matrix(y.data,ncol=length(vec.HH))
    
    count <- 0
    for(month.4.distri in considered.months){
      count <- count + 1
      if(count==1){
        plot(vec.HH/12,y.data[count,],
             type="l",ylim=y.lim,xlab=expression(paste("Horizon, years (=",h/12,")",sep="")),ylab="",lwd=2,
             main = Area)
      }else{
        if(length(vec.tt)>1){
          lines(vec.HH/12,y.data[count,],
                col="red",lty=2,lwd=3)
        }
      }
    }
    legend("topright",
           c(as.character(format(considered.months,"%m-%Y"))),
           lty=c(1,2),
           lwd=c(3,3),
           col=c("black","red"),
           seg.len=4,bg="white")  
  }
  
}

dev.off()
