

# Recession dates:
US.rec.dates <- as.Date(
  c("2001-03-15","2001-03-15","2001-11-15","2001-11-15",
    "2007-12-15","2007-12-15","2009-06-15","2009-06-15"),
  "%Y-%m-%d"
)
US.rec.dates <- c(US.rec.dates,US.rec.dates[length(US.rec.dates):1])

EA.rec.dates <- as.Date(
  c("2008-04-15","2008-04-15","2009-06-15","2009-06-15",
    "2011-10-15","2011-10-15","2013-03-15","2013-03-15"),
  "%Y-%m-%d"
)
EA.rec.dates <- c(EA.rec.dates,EA.rec.dates[length(EA.rec.dates):1])



# ==============================================
vec.HH <- c(60,120)
infl.type <- c(2,1)
# ==============================================

matrix.of.moments <- NULL

FILE = "/OUTPUTS/Figure_selected_horizons.pdf"
pdf(file=paste(getwd(),FILE,sep=""),pointsize=10,width=6, height=7)
par(mfrow=c(length(vec.HH),2))
par(plt=c(.1,.95,.15,.8))

count <- 0
for(HH in vec.HH){
  count <- count + 1
  all.res <- compute.two.moments(estimated.Model,X,HH,S,indic.5y.in.Xy = 1)
  if(count==1){
    main.t.1st <- "Conditional mean, 1Y4F inflation "
    main.t.2nd <- "Conditional variance, 1Y4F inflation "
    y.lim.2ndmoment <- c(0,1.5)
    y.lim.1stmoment <- c(1.5,3)
  }
  if(count==2){
    main.t.1st <- "Conditional mean, 5Y5F inflation "
    main.t.2nd <- "Conditional variance, 5Y5F inflation "
    y.lim.2ndmoment <- c(0,.7)
    y.lim.1stmoment <- c(1.5,3)
  }
  for(indic.1st.or.2nd in 1:2){
    if(indic.1st.or.2nd==1){
      y.lim <- y.lim.1stmoment
      main.t <- main.t.1st
    }else{
      y.lim <- y.lim.2ndmoment
      main.t <- main.t.2nd
    }
    for(area in 1:2){
      if(indic.1st.or.2nd==1){
        variable <- all.res$expect.1st.mom[,area,infl.type[count]]
        eval(parse(text = gsub('','',
                               paste('variable.name <- "conditional.mean.',
                                     ifelse(HH==60,'1Y4F.','5Y5F.'),
                                     ifelse(area==1,'EA"','US"'),
                                     "",sep=""))))
        eval(parse(text = gsub('','',
                               paste(variable.name,'<- variable',sep=""))))
        eval(parse(text = gsub('','',
                               paste('matrix.of.moments <- cbind(matrix.of.moments,',
                                     variable.name,')',
                                     "",sep=""))))

        lower.bound <- variable - 2 * sqrt(all.res$var.1st.mom[,area,infl.type[count]])
        upper.bound <- variable + 2 * sqrt(all.res$var.1st.mom[,area,infl.type[count]])
      }else{
        variable <- all.res$expect.2nd.mom[,area,infl.type[count]]
        variance.variable <- all.res$var.2nd.mom[,area,infl.type[count]]
        
        eval(parse(text = gsub('','',
                               paste('variable.name <- "conditional.var.',
                                     ifelse(HH==60,'1Y4F.','5Y5F.'),
                                     ifelse(area==1,'EA"','US"'),
                                     "",sep=""))))
        eval(parse(text = gsub('','',
                               paste(variable.name,'<- variable',sep=""))))
        eval(parse(text = gsub('','',
                               paste('matrix.of.moments <- cbind(matrix.of.moments,',
                                     variable.name,')',
                                     "",sep=""))))
        
        lower.bound <- variable - 2 * sqrt(variance.variable)
        upper.bound <- variable + 2 * sqrt(variance.variable)
      }
      
      if(area==1){
        plot(vec.dates,variable,type="l",
             ylim=y.lim,
             col="black",lwd=2,
             xlab="",ylab="",
             main=main.t)
        
        # Add recession dates:
        for(area.aux in 1:2){
          if(area.aux==1){
            rec.dates <- EA.rec.dates
            color.country <- "#EECCEE99"
          }else{
            rec.dates <- US.rec.dates
            color.country <- "#CCEEEE99"
          }
          #------ Add recession areas ------
          nb.rec <- length(rec.dates)/8
          polygon(rec.dates,c(rep(c(-10000,10000,10000,-10000),nb.rec),rep(-10000,nb.rec*4)),
                  col=color.country,border=NA)
          #---------------------------------
        }
        
        lines(vec.dates,variable,col="black",lwd=2)
        vec.dates <- vec.dates
        polygon(c(vec.dates,vec.dates[T:1]),c(lower.bound,upper.bound[T:1]),
                col="#10101044",border=NA)
      }else{
        lines(vec.dates,variable,type="l",
              ylim=c(0.2,1),
              col="dark grey",lwd=2,
              xlab="",ylab="Standard deviation, %")
        polygon(c(vec.dates,vec.dates[T:1]),c(lower.bound,upper.bound[T:1]),
                col="#90909044",border=NA)
      }
    }
    
    if(indic.1st.or.2nd==1){
      if((HH==60)&(infl.type[count]==2)){
        text(vec.dates[1],y.lim[2]-.04*(y.lim[2]-y.lim[1]),expression(paste(E[t],"(",pi[t+48*","*t+60],")")),pos=4)
      }
      if((HH==120)&(infl.type[count]==2)){
        text(vec.dates[1],y.lim[2]-.04*(y.lim[2]-y.lim[1]),expression(paste(E[t],"(",pi[t+108*","*t+120],")")),pos=4)
      }
      if((HH==120)&(infl.type[count]==1)){
        text(vec.dates[1],y.lim[2]-.04*(y.lim[2]-y.lim[1]),expression(paste(E[t],"(",pi[t+60*","*t+120],")")),pos=4)
      }
    }else{
      if((HH==60)&(infl.type[count]==2)){
        text(vec.dates[1],y.lim[2]-.04*(y.lim[2]-y.lim[1]),expression(paste(Var[t],"(",pi[t+48*","*t+60],")")),pos=4)
      }
      if((HH==120)&(infl.type[count]==2)){
        text(vec.dates[1],y.lim[2]-.04*(y.lim[2]-y.lim[1]),expression(paste(Var[t],"(",pi[t+108*","*t+120],")")),pos=4)
      }
      if((HH==120)&(infl.type[count]==1)){
        text(vec.dates[1],y.lim[2]-.04*(y.lim[2]-y.lim[1]),expression(paste(Var[t],"(",pi[t+60*","*t+120],")")),pos=4)
      }
    }
    
    legend("topright",
           c("Euro area","United States"),
           lty=c(1,1),
           lwd=c(2,2),
           col=c("black","dark grey"),
           seg.len = 4,bg="white"
    )
  }
}

dev.off()


write.csv(matrix.of.moments,file="OUTPUTS/time_series_conditional_moments.csv")
